## ecflow 5.13.7

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_CXX_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
##############################################################################

# need 3.12.0 as this has findBoost fix for the latest boost version 1.67
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

# ===========================================================================
# Change the default if NO CMAKE_BUILD_TYPE specified
if (NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build Configuration type" FORCE)
endif()

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild /workspace/ecbuild) # Before project()

project( ecflow LANGUAGES CXX VERSION 5.13.7 )

# Important: the project version is used, as generated CMake variables, to filter .../ecflow/core/ecflow_version.h.in

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.6 )
include(CompilerOptions)

###############################################################################
# local project

ecbuild_declare_project()

ecbuild_info( "CMAKE_MODULE_PATH        : ${CMAKE_MODULE_PATH}")
ecbuild_info( "CMAKE_INSTALL_PREFIX     : ${CMAKE_INSTALL_PREFIX}" )
ecbuild_info( "ecflow_BINARY_DIR        : ${ecflow_BINARY_DIR}" )
ecbuild_info( "ecflow_SOURCE_DIR        : ${ecflow_SOURCE_DIR}" )


# =========================================================================================
# Options , be aware of caching, when modifying on the command line. 
# Ideally start fresh or remove cache CmakeCache.txt in build dir
# =========================================================================================
option( ENABLE_SERVER              "Build the server, can be switched off if just building UI" ON  )
option( ENABLE_PYTHON              "enable python interface"         ON  )
option( ENABLE_UI                  "Build ecFlowUI"                  ON  ) 
option( ENABLE_STATIC_BOOST_LIBS   "Link with boost libs statically" ON  )
option( ENABLE_ALL_TESTS           "This includes performance/migration/regression tests" OFF )
option( ENABLE_UI_BACKTRACE        "Print a UI debug backtrace"         OFF ) 
option( ENABLE_UI_USAGE_LOG        "Enable UI usage logging"            OFF )
option( ENABLE_SSL                 "Enable SSL encrypted communication" ON )
option( ENABLE_PYTHON_PTR_REGISTER "Some compilers/boost versions do not register shared ptr automatically" OFF  )
option( ENABLE_HTTP                "Enable HTTP server (experimental)" ON  )
option( ENABLE_HTTP_COMPRESSION    "Enable compression support by HTTP server" ON )
option( ENABLE_UDP                 "Enable UDP server (experimental)" ON )
option( ENABLE_DOCS                "Enable Documentation" OFF )

include(Policies NO_POLICY_SCOPE)

# =========================================================================================
# Dependency: Qt
# =========================================================================================
# Qt for ecFlowUI.
# Algorithm: we test for Qt6 - if it's there, then use it; otherwise look for Qt5.
#            if we don't find that, then we cannot build ecFlowUI.
# -----------------------------------------------------------------------------------------
if(ENABLE_UI)

  ecbuild_info("")
  ecbuild_info("------------------------------ Qt start ---------------------------")
  ecbuild_info("ecFlowUI is enabled - searching for Qt6/Qt5")
  ecbuild_info("To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH")

  find_package(Qt6Widgets)
  if( Qt6Widgets_FOUND )
    find_package(Qt6Core5Compat  REQUIRED)
    find_package(Qt6Gui          REQUIRED)
    find_package(Qt6Network      REQUIRED)
    find_package(Qt6Svg          REQUIRED)
    find_package(Qt6Charts)

    ecbuild_debug("Qt6 version ${Qt6Widgets_VERSION_STRING} was found")
    set(ECFLOW_QT_INCLUDE_DIR ${Qt6Core5Compat_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Svg_INCLUDE_DIRS})
    set(ECFLOW_QT_LIBRARIES  ${Qt6Core5Compat_LIBRARIES} ${Qt6Widgets_LIBRARIES}    ${Qt6Gui_LIBRARIES}   ${Qt6Network_LIBRARIES} ${Qt6Svg_LIBRARIES})
    set(ECFLOW_QT6 1)
    add_definitions(-DECFLOW_QT6)

    if(Qt6Charts_FOUND)
      ecbuild_info("Qt6Charts was found - the server log viewer will be built")
      list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt6Charts_INCLUDE_DIRS})
      list(APPEND ECFLOW_QT_LIBRARIES  ${Qt6Charts_LIBRARIES})
      set(ECFLOW_LOGVIEW 1)
      add_definitions(-DECFLOW_LOGVIEW)
    else()
      ecbuild_info("Qt6Charts was not found - the server log viewer will not be built")
    endif()
  else()
    find_package(Qt5Widgets)
    if (Qt5Widgets_FOUND)
      find_package(Qt5Gui          REQUIRED)
      find_package(Qt5Network      REQUIRED)
      find_package(Qt5Svg          REQUIRED)
      find_package(Qt5Charts)

      ecbuild_info("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
      set(ECFLOW_QT_INCLUDE_DIR ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
      set(ECFLOW_QT_LIBRARIES   ${Qt5Widgets_LIBRARIES}    ${Qt5Gui_LIBRARIES}   ${Qt5Network_LIBRARIES} ${Qt5Svg_LIBRARIES})
      set(ECFLOW_QT5 1)
      add_definitions(-DECFLOW_QT5)

      if(Qt5Charts_FOUND)
        ecbuild_info("Qt5Charts was found - the server log viewer will be built")
        list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt5Charts_INCLUDE_DIRS})
        list(APPEND ECFLOW_QT_LIBRARIES  ${Qt5Charts_LIBRARIES})
        set(ECFLOW_LOGVIEW 1)
        add_definitions(-DECFLOW_LOGVIEW)
      else()
        ecbuild_info("Qt5Charts was not found - the server log viewer will not be built")
      endif()
    else()
      ecbuild_critical("Qt5 Widgets, Network and Gui not found - these are required for ecFlowUI; or use -DENABLE_UI=OFF")
    endif()
  endif()

  set(ECFLOW_QT 1)
  add_definitions(-DQT_NO_KEYWORDS) # We need to disable keywords because there is a problem in using Qt and boost together.
  ecbuild_info("------------------------------ Qt end----------------------------")
  ecbuild_info("")

endif()


# sanity check - cannot set ENABLE_UI_BACKTRACE if UI is OFF
if(ENABLE_UI_BACKTRACE AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot ENABLE_UI_BACKTRACE if UI is not enabled")
  set(ENABLE_UI_BACKTRACE OFF)
endif()

# sanity check - cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI and ENABLE_UI_BACKTRACE are OFF
if(UI_BACKTRACE_EMAIL_ADDRESS_FILE AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI is not enabled")
  set(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
endif()

# sanity check - cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is OFF
if(UI_LOG_FILE AND (NOT ENABLE_UI_USAGE_LOG))
  ecbuild_warn("Cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is not enabled")
  set(UI_LOG_FILE)
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_FILE))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT LOGUI_LOG_FILE))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, LOGUI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_SITE_TAG
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_SITE_TAG))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_SITE_TAG must also be set")
endif()

# sanity check - cannot set UI_SYSTEM_SERVERS_LIST if UI IS OFF
if(UI_SYSTEM_SERVERS_LIST AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot set UI_SYSTEM_SERVERS_LIST if UI is not enabled")
  set(UI_SYSTEM_SERVERS_LIST)
endif()

if(ENABLE_HTTP AND NOT ENABLE_SERVER)
  ecbuild_warn("ENABLE_SERVER is disabled, therefore HTTP_SERVER will also be disabled")
  set(ENABLE_HTTP OFF)
endif()

if(ENABLE_UDP AND NOT ENABLE_SERVER)
  ecbuild_warn("ENABLE_SERVER is disabled, therefore UDP_SERVER will also be disabled")
  set(ENABLE_UDP OFF)
endif()


ecbuild_info( "ENABLE_SERVER              : ${ENABLE_SERVER}" )
ecbuild_info( "ENABLE_PYTHON              : ${ENABLE_PYTHON}" )
ecbuild_info( "ENABLE_PYTHON_PTR_REGISTER : ${ENABLE_PYTHON_PTR_REGISTER}" )
ecbuild_info( "ENABLE_UI                  : ${ENABLE_UI}" )
ecbuild_info( "ENABLE_TESTS               : ${ENABLE_TESTS} *if* disabled no need for boost test libs" )
ecbuild_info( "ENABLE_ALL_TESTS           : ${ENABLE_ALL_TESTS}" )
ecbuild_info( "ENABLE_STATIC_BOOST_LIBS   : ${ENABLE_STATIC_BOOST_LIBS}" )
ecbuild_info( "ENABLE_SSL                 : ${ENABLE_SSL} *if* openssl libraries available" )
ecbuild_info( "ENABLE_HTTP                : ${ENABLE_HTTP}" )
ecbuild_info( "ENABLE_HTTP_COMPRESSION    : ${ENABLE_HTTP_COMPRESSION}" )
ecbuild_info( "ENABLE_UDP                 : ${ENABLE_UDP}" )


if (ENABLE_UI)
  ecbuild_info( "ENABLE_UI_BACKTRACE        : ${ENABLE_UI_BACKTRACE}" )
  if (UI_BACKTRACE_EMAIL_ADDRESS_FILE)
    ecbuild_info( "UI_BACKTRACE_EMAIL_ADDRESS_FILE : ${UI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
  endif()

  if(LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE)
    ecbuild_info( "LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE : ${LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
  endif()

  if(UI_SYSTEM_SERVERS_LIST)
    ecbuild_info( "UI_SYSTEM_SERVERS_LIST : ${UI_SYSTEM_SERVERS_LIST}" )
  endif()

  ecbuild_info( "ENABLE_UI_USAGE_LOG        : ${ENABLE_UI_USAGE_LOG}" )
  if(ENABLE_UI_USAGE_LOG)
    ecbuild_info( "UI_LOG_FILE                : ${UI_LOG_FILE}" )
    ecbuild_info( "LOGUI_LOG_FILE             : ${LOGUI_LOG_FILE}" )
    ecbuild_info( "UI_LOG_SITE_TAG            : ${UI_LOG_SITE_TAG}" )
  endif()
endif()
ecbuild_info("")


# =========================================================================================
# Setup Project-wide dependencies
# =========================================================================================
include(Dependencies)

# =========================================================================================
# Dependency: Boost
# =========================================================================================
message( STATUS "====================================================================================================================" )
message( STATUS "BOOST" )
# this can help in some situations:
set (_CMAKE_PREFIX_PATH_BACKUP ${CMAKE_PREFIX_PATH}) # make a backup of CMAKE_PREFIX_PATH
foreach(BOOST_PATH_TO_SEARCH ${BOOST_PATH} ${BOOST_ROOT} $ENV{BOOST_ROOT})
    ecbuild_debug("adding: ${BOOST_PATH_TO_SEARCH} to CMAKE_PREFIX_PATH")
    list(APPEND CMAKE_PREFIX_PATH ${BOOST_PATH_TO_SEARCH})
    list(REMOVE_DUPLICATES CMAKE_PREFIX_PATH)
endforeach()

# Ecflow test require statics libs for boost < 1.59, otherwise get double free error.
# To use static boost python ensure that Boost_USE_STATIC_LIBS is set on.
# See: http://www.cmake.org/cmake/help/v3.0/module/FindBoost.html
if ( ENABLE_STATIC_BOOST_LIBS )
    set(Boost_USE_STATIC_LIBS ON)
    ecbuild_info( "Using STATIC boost libraries : ${BOOST_TEST_DYN_LINK}" )
else()
    set(BOOST_TEST_DYN_LINK "BOOST_TEST_DYN_LINK")
    ecbuild_info( "Using SHARED boost libraries setting : ${BOOST_TEST_DYN_LINK}" )
endif()

# By default cmake assume boost was built with cmake. Hence looks for package config file BoostConfig.cmake/boost-config.cmake
# This seems to mess up the search for boost python libs.
# if Boost_NO_BOOST_CMAKE is not set, we seem to mess up in finding right python libs(python3 and python2), 
# for boost 1.71 and cmake 3.15 or greater
set(Boost_NO_BOOST_CMAKE ON) 

set(Boost_USE_MULTITHREADED  ON)

=== Viewer/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

add_subdirectory( libViewer)
add_subdirectory( ecflowUI)

=== docs/CMakeLists.txt ===
#
# Copyright 2009-2023 ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

#
# Setup Sphinx
#

find_package(Sphinx REQUIRED)


#
# (Re-)generate ecFlow CLI documentation
#

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/client_api/api)
add_custom_command(
  OUTPUT generate_ecflow_client_docs
  COMMAND
    ${CMAKE_COMMAND} -E rm -rf ${CMAKE_CURRENT_SOURCE_DIR}/client_api/api/*
  COMMAND
    ${CMAKE_COMMAND} -E env "PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}"
        ${CMAKE_CURRENT_SOURCE_DIR}/client_api/build.py
  COMMAND
    ${CMAKE_COMMAND} -E copy_directory
      ${CMAKE_CURRENT_BINARY_DIR}/client_api/api
      ${CMAKE_CURRENT_SOURCE_DIR}/client_api/api
  COMMAND
    ${CMAKE_COMMAND} -E copy
      ${CMAKE_CURRENT_BINARY_DIR}/client_api/index.rst
      ${CMAKE_CURRENT_SOURCE_DIR}/client_api
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/client_api
  USES_TERMINAL
  DEPENDS ecflow_client
)
add_custom_target(ecflow_client_docs DEPENDS generate_ecflow_client_docs)


#
# (Re-)generate ecFlow Python documentation
#

message(STATUS "***> ${SPHINX_EXECUTABLE}")

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build_python_api/rst)
add_custom_command(
  OUTPUT generate_ecflow_python_docs
  COMMAND
    ${CMAKE_COMMAND} -E rm -rf ${CMAKE_CURRENT_SOURCE_DIR}/python_api/*
  COMMAND
    ${CMAKE_COMMAND} -E rm -rf ${CMAKE_CURRENT_BINARY_DIR}/build_python_api/rst/*
  COMMAND
    ${CMAKE_COMMAND} -E rm -rf ${CMAKE_CURRENT_BINARY_DIR}/build_python_api/_build
  COMMAND
    ${CMAKE_COMMAND} -E env "PYTHONPATH=${CMAKE_BINARY_DIR}/libs/pyext/python3"
        ${SPHINX_EXECUTABLE} -M html
          ${CMAKE_CURRENT_SOURCE_DIR}/build_python_api
          ${CMAKE_CURRENT_BINARY_DIR}/build_python_api/_build
  COMMAND
    ${CMAKE_COMMAND} -E copy
        ${CMAKE_CURRENT_SOURCE_DIR}/build_python_api/glossary.yaml
        ${CMAKE_CURRENT_SOURCE_DIR}/build_python_api/categories.yaml
        ${CMAKE_CURRENT_BINARY_DIR}/build_python_api
  COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/build_python_api/fix_rst.py
  COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/build_python_api/build_toc.py
  COMMAND
    ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/build_python_api/python_api.rst ${CMAKE_CURRENT_SOURCE_DIR}/python_api
  COMMAND
    ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/build_python_api/rst/* ${CMAKE_CURRENT_SOURCE_DIR}/python_api
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/build_python_api
  USES_TERMINAL
  DEPENDS ecflow3
)
add_custom_target(ecflow_python_docs DEPENDS generate_ecflow_python_docs)

#
# Build ecFlow documentation
#

add_custom_command(
  OUTPUT generate_ecflow_docs
  COMMAND
    ${CMAKE_COMMAND} -E env "PYTHONPATH=${CMAKE_BINARY_DIR}/libs/pyext/python3"
      ${SPHINX_EXECUTABLE} -M html
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${CMAKE_CURRENT_BINARY_DIR}/_build
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  USES_TERMINAL
  DEPENDS
    ecflow_client_docs
    ecflow_python_docs
)
add_custom_target(ecflow_docs DEPENDS generate_ecflow_docs)

=== libs/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

configure_file(
  core/src/ecflow/core/ecflow_version.h.in
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_version.h)
configure_file(
  core/src/ecflow/core/ecflow_source_build_dir.h.in
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_source_build_dir.h)

set(srcs
  # Attribute -- Headers
  attribute/src/ecflow/attribute/AutoArchiveAttr.hpp
  attribute/src/ecflow/attribute/AutoCancelAttr.hpp
  attribute/src/ecflow/attribute/ClockAttr.hpp
  attribute/src/ecflow/attribute/CronAttr.hpp
  attribute/src/ecflow/attribute/DateAttr.hpp
  attribute/src/ecflow/attribute/DayAttr.hpp
  attribute/src/ecflow/attribute/GenericAttr.hpp
  attribute/src/ecflow/attribute/LateAttr.hpp
  attribute/src/ecflow/attribute/NodeAttr.hpp
  attribute/src/ecflow/attribute/QueueAttr.hpp
  attribute/src/ecflow/attribute/RepeatAttr.hpp
  attribute/src/ecflow/attribute/RepeatRange.hpp
  attribute/src/ecflow/attribute/TimeAttr.hpp
  attribute/src/ecflow/attribute/TodayAttr.hpp
  attribute/src/ecflow/attribute/Variable.hpp
  attribute/src/ecflow/attribute/VerifyAttr.hpp
  attribute/src/ecflow/attribute/Zombie.hpp
  attribute/src/ecflow/attribute/ZombieAttr.hpp
  # Attribute -- Sources
  attribute/src/ecflow/attribute/AutoArchiveAttr.cpp
  attribute/src/ecflow/attribute/AutoCancelAttr.cpp
  attribute/src/ecflow/attribute/ClockAttr.cpp
  attribute/src/ecflow/attribute/CronAttr.cpp
  attribute/src/ecflow/attribute/DateAttr.cpp
  attribute/src/ecflow/attribute/DayAttr.cpp
  attribute/src/ecflow/attribute/GenericAttr.cpp
  attribute/src/ecflow/attribute/LateAttr.cpp
  attribute/src/ecflow/attribute/NodeAttr.cpp
  attribute/src/ecflow/attribute/QueueAttr.cpp
  attribute/src/ecflow/attribute/RepeatAttr.cpp
  attribute/src/ecflow/attribute/TimeAttr.cpp
  attribute/src/ecflow/attribute/TodayAttr.cpp
  attribute/src/ecflow/attribute/Variable.cpp
  attribute/src/ecflow/attribute/VerifyAttr.cpp
  attribute/src/ecflow/attribute/Zombie.cpp
  attribute/src/ecflow/attribute/ZombieAttr.cpp

  # Base -- Headers
  base/src/ecflow/base/AbstractClientEnv.hpp
  base/src/ecflow/base/AbstractServer.hpp
  base/src/ecflow/base/Client.hpp
  base/src/ecflow/base/ClientOptionsParser.hpp
  base/src/ecflow/base/ClientToServerRequest.hpp
  base/src/ecflow/base/Cmd.hpp
  base/src/ecflow/base/Connection.hpp
  base/src/ecflow/base/Gnuplot.hpp
  base/src/ecflow/base/ServerReply.hpp
  base/src/ecflow/base/ServerToClientResponse.hpp
  base/src/ecflow/base/Stats.hpp
  base/src/ecflow/base/WhyCmd.hpp
  base/src/ecflow/base/ZombieCtrl.hpp
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/Openssl.hpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/ssl_connection.hpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/SslClient.hpp>
  base/src/ecflow/base/cts/ClientToServerCmd.hpp
  base/src/ecflow/base/cts/CtsCmdRegistry.hpp
  base/src/ecflow/base/cts/EditHistoryMgr.hpp
  base/src/ecflow/base/cts/task/AbortCmd.hpp
  base/src/ecflow/base/cts/task/CompleteCmd.hpp
  base/src/ecflow/base/cts/task/CtsWaitCmd.hpp
  base/src/ecflow/base/cts/task/EventCmd.hpp
  base/src/ecflow/base/cts/task/InitCmd.hpp
  base/src/ecflow/base/cts/task/LabelCmd.hpp
  base/src/ecflow/base/cts/task/MeterCmd.hpp
  base/src/ecflow/base/cts/task/QueueCmd.hpp
  base/src/ecflow/base/cts/task/TaskApi.hpp
  base/src/ecflow/base/cts/task/TaskCmd.hpp
  base/src/ecflow/base/cts/user/AlterCmd.hpp
  base/src/ecflow/base/cts/user/BeginCmd.hpp
  base/src/ecflow/base/cts/user/CFileCmd.hpp
  base/src/ecflow/base/cts/user/CheckPtCmd.hpp
  base/src/ecflow/base/cts/user/ClientHandleCmd.hpp
  base/src/ecflow/base/cts/user/CSyncCmd.hpp
  base/src/ecflow/base/cts/user/CtsApi.hpp
  base/src/ecflow/base/cts/user/CtsCmd.hpp
  base/src/ecflow/base/cts/user/CtsNodeCmd.hpp
  base/src/ecflow/base/cts/user/DeleteCmd.hpp
  base/src/ecflow/base/cts/user/EditScriptCmd.hpp
  base/src/ecflow/base/cts/user/ForceCmd.hpp
  base/src/ecflow/base/cts/user/FreeDepCmd.hpp
  base/src/ecflow/base/cts/user/GroupCTSCmd.hpp
  base/src/ecflow/base/cts/user/LoadDefsCmd.hpp
  base/src/ecflow/base/cts/user/LogCmd.hpp
  base/src/ecflow/base/cts/user/LogMessageCmd.hpp
  base/src/ecflow/base/cts/user/MoveCmd.hpp
  base/src/ecflow/base/cts/user/OrderNodeCmd.hpp
  base/src/ecflow/base/cts/user/PathsCmd.hpp
  base/src/ecflow/base/cts/user/PlugCmd.hpp
  base/src/ecflow/base/cts/user/QueryCmd.hpp
  base/src/ecflow/base/cts/user/ReplaceNodeCmd.hpp
  base/src/ecflow/base/cts/user/RequeueNodeCmd.hpp
  base/src/ecflow/base/cts/user/RunNodeCmd.hpp
  base/src/ecflow/base/cts/user/ServerVersionCmd.hpp
  base/src/ecflow/base/cts/user/ShowCmd.hpp
  base/src/ecflow/base/cts/user/UserCmd.hpp
  base/src/ecflow/base/cts/user/ZombieCmd.hpp
  base/src/ecflow/base/stc/BlockClientZombieCmd.hpp
  base/src/ecflow/base/stc/DefsCache.hpp
  base/src/ecflow/base/stc/DefsCmd.hpp
  base/src/ecflow/base/stc/ErrorCmd.hpp
  base/src/ecflow/base/stc/GroupSTCCmd.hpp
  base/src/ecflow/base/stc/PreAllocatedReply.hpp
  base/src/ecflow/base/stc/SClientHandleCmd.hpp
  base/src/ecflow/base/stc/SClientHandleSuitesCmd.hpp
  base/src/ecflow/base/stc/SNewsCmd.hpp
  base/src/ecflow/base/stc/SNodeCmd.hpp
  base/src/ecflow/base/stc/SServerLoadCmd.hpp
  base/src/ecflow/base/stc/SStatsCmd.hpp
  base/src/ecflow/base/stc/SStringCmd.hpp
  base/src/ecflow/base/stc/SStringVecCmd.hpp
  base/src/ecflow/base/stc/SSuitesCmd.hpp
  base/src/ecflow/base/stc/SSyncCmd.hpp
  base/src/ecflow/base/stc/ServerToClientCmd.hpp
  base/src/ecflow/base/stc/StcCmd.hpp
  base/src/ecflow/base/stc/ZombieGetCmd.hpp
  # Base -- Sources
  base/src/ecflow/base/Client.cpp
  base/src/ecflow/base/ClientOptionsParser.cpp
  base/src/ecflow/base/ClientToServerRequest.cpp
  base/src/ecflow/base/Connection.cpp
  base/src/ecflow/base/Gnuplot.cpp
  base/src/ecflow/base/ServerReply.cpp
  base/src/ecflow/base/ServerToClientResponse.cpp
  base/src/ecflow/base/Stats.cpp
  base/src/ecflow/base/WhyCmd.cpp
  base/src/ecflow/base/ZombieCtrl.cpp
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/Openssl.cpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/ssl_connection.cpp>
  $<$<BOOL:${OPENSSL_FOUND}>:base/src/ecflow/base/SslClient.cpp>
  base/src/ecflow/base/cts/ClientToServerCmd.cpp
  base/src/ecflow/base/cts/CtsCmdRegistry.cpp
  base/src/ecflow/base/cts/EditHistoryMgr.cpp
  base/src/ecflow/base/cts/task/AbortCmd.cpp
  base/src/ecflow/base/cts/task/CompleteCmd.cpp
  base/src/ecflow/base/cts/task/CtsWaitCmd.cpp
  base/src/ecflow/base/cts/task/EventCmd.cpp
  base/src/ecflow/base/cts/task/InitCmd.cpp
  base/src/ecflow/base/cts/task/LabelCmd.cpp
  base/src/ecflow/base/cts/task/MeterCmd.cpp
  base/src/ecflow/base/cts/task/QueueCmd.cpp
  base/src/ecflow/base/cts/task/TaskApi.cpp
  base/src/ecflow/base/cts/task/TaskCmd.cpp
  base/src/ecflow/base/cts/user/AlterCmd.cpp
  base/src/ecflow/base/cts/user/BeginCmd.cpp
  base/src/ecflow/base/cts/user/CFileCmd.cpp
  base/src/ecflow/base/cts/user/CSyncCmd.cpp
  base/src/ecflow/base/cts/user/CheckPtCmd.cpp
  base/src/ecflow/base/cts/user/ClientHandleCmd.cpp
  base/src/ecflow/base/cts/user/CtsApi.cpp
  base/src/ecflow/base/cts/user/CtsCmd.cpp
  base/src/ecflow/base/cts/user/CtsNodeCmd.cpp
  base/src/ecflow/base/cts/user/DeleteCmd.cpp
  base/src/ecflow/base/cts/user/EditScriptCmd.cpp
  base/src/ecflow/base/cts/user/ForceCmd.cpp
  base/src/ecflow/base/cts/user/FreeDepCmd.cpp
  base/src/ecflow/base/cts/user/GroupCTSCmd.cpp
  base/src/ecflow/base/cts/user/LoadDefsCmd.cpp
  base/src/ecflow/base/cts/user/LogCmd.cpp
  base/src/ecflow/base/cts/user/LogMessageCmd.cpp
  base/src/ecflow/base/cts/user/MoveCmd.cpp
  base/src/ecflow/base/cts/user/OrderNodeCmd.cpp
  base/src/ecflow/base/cts/user/PathsCmd.cpp
  base/src/ecflow/base/cts/user/PlugCmd.cpp
  base/src/ecflow/base/cts/user/QueryCmd.cpp
  base/src/ecflow/base/cts/user/ReplaceNodeCmd.cpp
  base/src/ecflow/base/cts/user/RequeueNodeCmd.cpp
  base/src/ecflow/base/cts/user/RunNodeCmd.cpp
  base/src/ecflow/base/cts/user/ServerVersionCmd.cpp
  base/src/ecflow/base/cts/user/ShowCmd.cpp
  base/src/ecflow/base/cts/user/UserCmd.cpp
  base/src/ecflow/base/cts/user/ZombieCmd.cpp
  base/src/ecflow/base/stc/BlockClientZombieCmd.cpp
  base/src/ecflow/base/stc/DefsCache.cpp
  base/src/ecflow/base/stc/DefsCmd.cpp
  base/src/ecflow/base/stc/ErrorCmd.cpp
  base/src/ecflow/base/stc/GroupSTCCmd.cpp
  base/src/ecflow/base/stc/PreAllocatedReply.cpp
  base/src/ecflow/base/stc/SClientHandleCmd.cpp
  base/src/ecflow/base/stc/SClientHandleSuitesCmd.cpp
  base/src/ecflow/base/stc/SNewsCmd.cpp
  base/src/ecflow/base/stc/SNodeCmd.cpp
  base/src/ecflow/base/stc/SServerLoadCmd.cpp
  base/src/ecflow/base/stc/SStatsCmd.cpp
  base/src/ecflow/base/stc/SStringCmd.cpp
  base/src/ecflow/base/stc/SStringVecCmd.cpp
  base/src/ecflow/base/stc/SSuitesCmd.cpp
  base/src/ecflow/base/stc/SSyncCmd.cpp
  base/src/ecflow/base/stc/ServerToClientCmd.cpp
  base/src/ecflow/base/stc/StcCmd.cpp
  base/src/ecflow/base/stc/ZombieGetCmd.cpp

  # Client -- Headers
  client/src/ecflow/client/ClientCmdCache.hpp
  client/src/ecflow/client/ClientEnvironment.hpp
  client/src/ecflow/client/ClientInvoker.hpp
  client/src/ecflow/client/ClientOptions.hpp
  client/src/ecflow/client/Help.hpp
  client/src/ecflow/client/Rtt.hpp
  client/src/ecflow/client/UrlCmd.hpp
  # Client -- Sources
  client/src/ecflow/client/ClientCmdCache.cpp
  client/src/ecflow/client/Rtt.cpp
  client/src/ecflow/client/ClientEnvironment.cpp
  client/src/ecflow/client/ClientInvoker.cpp
  client/src/ecflow/client/Help.cpp
  client/src/ecflow/client/Rtt.cpp
  client/src/ecflow/client/ClientOptions.cpp
  client/src/ecflow/client/UrlCmd.cpp

  # Core -- Headers
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_version.h
  ${CMAKE_BINARY_DIR}/generated/src/ecflow/core/ecflow_source_build_dir.h
  core/src/ecflow/core/AssertTimer.hpp
  core/src/ecflow/core/Cal.hpp
  core/src/ecflow/core/Calendar.hpp
  core/src/ecflow/core/CalendarUpdateParams.hpp
  core/src/ecflow/core/CheckPt.hpp
  core/src/ecflow/core/Child.hpp
  core/src/ecflow/core/Chrono.hpp
  core/src/ecflow/core/CommandLine.hpp
  core/src/ecflow/core/DState.hpp
  core/src/ecflow/core/DebugPerf.hpp
  core/src/ecflow/core/DurationTimer.hpp
  core/src/ecflow/core/Ecf.hpp
  core/src/ecflow/core/EcfPortLock.hpp
  core/src/ecflow/core/Extract.hpp
  core/src/ecflow/core/File.hpp
  core/src/ecflow/core/File_r.hpp
  core/src/ecflow/core/Filesystem.hpp
  core/src/ecflow/core/Host.hpp
  core/src/ecflow/core/Indentor.hpp
  core/src/ecflow/core/Log.hpp
  core/src/ecflow/core/LogVerification.hpp
  core/src/ecflow/core/Message.hpp
  core/src/ecflow/core/NOrder.hpp
  core/src/ecflow/core/NState.hpp
  core/src/ecflow/core/NodePath.hpp
  core/src/ecflow/core/Overload.hpp
  core/src/ecflow/core/Passwd.hpp
  core/src/ecflow/core/PasswdFile.hpp
  core/src/ecflow/core/PasswordEncryption.hpp
  core/src/ecflow/core/Pid.hpp
  core/src/ecflow/core/PrintStyle.hpp
  core/src/ecflow/core/SState.hpp
  core/src/ecflow/core/Serialization.hpp
  core/src/ecflow/core/Stl.hpp
  core/src/ecflow/core/Str.hpp
  core/src/ecflow/core/StringSplitter.hpp
  core/src/ecflow/core/TimeSeries.hpp
  core/src/ecflow/core/TimeSlot.hpp
  core/src/ecflow/core/TimeStamp.hpp
  core/src/ecflow/core/User.hpp
  core/src/ecflow/core/Version.hpp
  core/src/ecflow/core/WhiteListFile.hpp
  core/src/ecflow/core/cereal_boost_time.hpp
  core/src/ecflow/core/cereal_optional_nvp.hpp
  core/src/ecflow/core/perf_timer.hpp
  core/src/ecflow/core/exceptions/Exceptions.hpp
  # Core -- Sources
  core/src/ecflow/core/AssertTimer.cpp
  core/src/ecflow/core/Cal.cpp
  core/src/ecflow/core/Calendar.cpp
  core/src/ecflow/core/Child.cpp
  core/src/ecflow/core/Chrono.cpp

=== 3rdparty/cereal/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6.2)
project (cereal)

option(SKIP_PORTABILITY_TEST "Skip portability (32 bit) tests" OFF)
option(SKIP_PERFORMANCE_COMPARISON "Skip building performance comparison (requires boost)" OFF)
if(NOT CMAKE_VERSION VERSION_LESS 3.0) # installing cereal requires INTERFACE lib
    option(JUST_INSTALL_CEREAL "Don't do anything besides installing the library" OFF)
endif()

option(THREAD_SAFE "Use mutexes to ensure thread safety" OFF)
if(THREAD_SAFE)
    add_definitions(-DCEREAL_THREAD_SAFE=1)
    set(CEREAL_THREAD_LIBS "pthread")
else()
    set(CEREAL_THREAD_LIBS "")
endif()

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /W3 /WX")
else()
    set(CMAKE_CXX_FLAGS "-Wall -g -Wextra -Wshadow -pedantic -Wold-style-cast ${CMAKE_CXX_FLAGS}")
    option(WITH_WERROR "Compile with '-Werror' C++ compiler flag" ON)
    if(WITH_WERROR)
        set(CMAKE_CXX_FLAGS "-Werror ${CMAKE_CXX_FLAGS}")
    endif(WITH_WERROR)

    option(CLANG_USE_LIBCPP "Use libc++ for clang compilation" OFF)
    if(CLANG_USE_LIBCPP)
        set(CMAKE_CXX_FLAGS "-stdlib=libc++ ${CMAKE_CXX_FLAGS}")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++ -lc++abi")
    endif()

    if(CMAKE_VERSION VERSION_LESS 3.1)
        set(CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
    else()
      if(NOT DEFINED CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD STREQUAL "98")
        set(CMAKE_CXX_STANDARD 11)
      endif()

      if(CMAKE_CXX_STANDARD GREATER 14)
        cmake_minimum_required(VERSION 3.8)
      endif()

      set(CMAKE_CXX_STANDARD_REQUIRED ON)
    endif()

endif()

if(NOT CMAKE_VERSION VERSION_LESS 3.0)
    add_library(cereal INTERFACE)
    target_include_directories(cereal INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    )
    install(TARGETS cereal EXPORT cereal
        DESTINATION lib) # ignored
    install(EXPORT cereal FILE cereal-config.cmake
        DESTINATION share/cmake/cereal)
    install(DIRECTORY include/cereal DESTINATION include)
endif()

if(JUST_INSTALL_CEREAL)
    return()
endif()

include_directories(./include)

if(NOT CMAKE_VERSION VERSION_LESS 3.12)
  cmake_policy(VERSION 3.12)
endif()

# Boost serialization for performance sandbox
find_package(Boost COMPONENTS serialization)

if(Boost_FOUND)
  include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
endif(Boost_FOUND)
  
enable_testing()
add_subdirectory(unittests)

add_subdirectory(sandbox)

add_subdirectory(doc)

=== docs/build_python_api/requirements.txt ===
# These are the requirements for readthedoc
docutils<=0.16.0
Sphinx>=4.4.0
setuptools>=51.0.0
sphinx-rtd-theme>=0.5.0
pyyaml

=== libs/attribute/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(test_srcs
  # Sources
  test/TestAttributes_main.cpp
  test/TestAttrSerialization.cpp
  test/TestCron.cpp
  test/TestDateAttr.cpp
  test/TestDayAttr.cpp
  test/TestLabel.cpp
  test/TestLateAttr.cpp
  test/TestMigration.cpp
  test/TestRepeat.cpp
  test/TestRepeatRange.cpp
  test/TestSizeOf.cpp
  test/TestTimeAttr.cpp
  test/TestTodayAttr.cpp
  test/TestVariable.cpp
  test/TestVariableMap.cpp
  test/TestZombieAttr.cpp
)

ecbuild_add_test(
  TARGET
    u_attributes
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    ../core/test
  LIBS
    ecflow_all
    test_scaffold
  TEST_DEPENDS
    u_core
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
)
target_clangformat(u_attributes
  CONDITION ENABLE_TESTS
)

=== libs/node/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(test_srcs
  # Headers
  test/MyDefsFixture.hpp
  # Sources
  test/TestAdd.cpp
  test/TestAlias.cpp
  test/TestAssignmentOperator.cpp
  test/TestChangeMgrSingleton.cpp
  test/TestClientSuiteMgr.cpp
  test/TestCopyConstructor.cpp
  test/TestDefStatus.cpp
  test/TestDefs.cpp
  test/TestEcfFile.cpp
  test/TestEcfFileLocator.cpp
  test/TestEnviromentSubstitution.cpp
  test/TestExprParser.cpp
  test/TestExprRepeatDateArithmetic.cpp
  test/TestExprRepeatDateListArithmetic.cpp
  test/TestFindAbsNodePath.cpp
  test/TestFlag.cpp
  test/TestHistoryParser.cpp
  test/TestInLimit.cpp
  test/TestJobCreator.cpp
  test/TestJobProfiler.cpp
  test/TestLimit.cpp
  test/TestMigration.cpp
  test/TestMissNextTimeSlot.cpp
  test/TestMovePeer.cpp
  test/TestNodeBeginRequeue.cpp
  test/TestNodeState.cpp
  test/TestNode_main.cpp # test entry point
  test/TestOrder.cpp
  test/TestPersistence.cpp
  test/TestPreProcessing.cpp
  test/TestRepeatWithTimeDependencies.cpp
  test/TestReplace.cpp
  test/TestSetState.cpp
  test/TestSpecificIssues.cpp
  test/TestSystem.cpp
  test/TestTaskScriptGenerator.cpp
  test/TestTimeDependencies.cpp
  test/TestVariableGeneration.cpp
  test/TestVariableInheritance.cpp
  test/TestVariableSubstitution.cpp
  test/TestVariableSubstitutionDefs.cpp
  test/TestZombies.cpp
)

ecbuild_add_test(
  TARGET
    u_node
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  LIBS
    ecflow_all
    test_scaffold
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
  TEST_DEPENDS
    u_attributes
)
target_clangformat(u_node
  CONDITION ENABLE_TESTS)


set(test_srcs
  # Headers
  test/parser/PersistHelper.hpp
  test/parser/TemporaryFile.hpp
  # Sources
  test/parser/PersistHelper.cpp
  test/parser/TemporaryFile.cpp
  test/parser/TestAutoAddExterns.cpp
  test/parser/TestAvisoAttr.cpp
  test/parser/TestDefsStructurePersistAndReload.cpp
  test/parser/TestMementoPersistAndReload.cpp
  test/parser/TestMigration.cpp
  test/parser/TestMirrorAttr.cpp
  test/parser/TestParser.cpp
  test/parser/TestParser_main.cpp # test entry point
  test/parser/TestVariableParsing.cpp
)
ecbuild_add_test(
  TARGET
    u_parser
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    test
    test/parser
  LIBS
    ecflow_all
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
  TEST_DEPENDS
    u_node
)
target_clangformat(u_parser
  CONDITION ENABLE_TESTS
)

if (ENABLE_ALL_TESTS)
  set(test_srcs
    test/TestSingleExprParse.cpp
    test/TestSingleExprParse_main.cpp # test entry point
  )

  ecbuild_add_test(
    TARGET
      u_node_single
    LABELS
      unit
      nightly
    SOURCES
      ${test_srcs}
    LIBS
      ecflow_all
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    TEST_DEPENDS
      u_anattr
  )
  target_clangformat(u_node_single
    CONDITION ENABLE_TESTS
  )


  set(test_srcs
    # Headers
    test/parser/PersistHelper.hpp
    test/parser/TemporaryFile.hpp
    # Sources
    test/parser/PersistHelper.cpp
    test/parser/TemporaryFile.cpp
    test/parser/TestParserPerformance_main.cpp # test entry point
    test/parser/TestSingleDefsFile.cpp
  )

  ecbuild_add_test(
    TARGET
      p_parser
    LABELS
      performance
      nightly
    SOURCES
      ${test_srcs}
    LIBS
      ecflow_all
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
      Boost::timer
  )
  target_clangformat(p_parser
    CONDITION ENABLE_TESTS
  )


  set(test_srcs
    # Headers
    test/parser/PersistHelper.hpp
    test/parser/TemporaryFile.hpp
    # Sources
    test/parser/ParseTimer.cpp
    test/parser/PersistHelper.cpp
    test/parser/TemporaryFile.cpp
  )

  # The following is not technically a test (as it makes no checks),
  # but a tool to measure the time it takes to parse 'mega.def' file
  ecbuild_add_test(
    TARGET
      p_parser_timer
    LABELS
      performance
      nightly
    ARGS
      ${CMAKE_CURRENT_SOURCE_DIR}/test/parser/data/single_defs/mega.def
    SOURCES
      ${test_srcs}
    LIBS
      ecflow_all
      Boost::boost # Boost header-only libraries must be available
      Boost::timer
  )
  target_clangformat(p_parser_timer
    CONDITION ENABLE_TESTS
  )

  # The following is not technically a test (as it makes no checks),
  # but a tool to parse 'mega.def' file
  set(test_srcs
    test/parser/ParseOnly.cpp
  )
  ecbuild_add_test(
    TARGET
      p_parser_only
    LABELS
      performance
      nightly
    ARGS
      ${CMAKE_CURRENT_SOURCE_DIR}/test/parser/data/single_defs/mega.def
    SOURCES
      ${test_srcs}
    LIBS
      ecflow_all
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
  )
  target_clangformat(p_parser_only
    CONDITION ENABLE_TESTS
  )

endif()

=== libs/pyext/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

### ecflow python bindings
# NOTES:
# 1/ Building multiple python3 versions not supported, since find_python(..) caches variables, Hack: clear cached variable.
#    https://gitlab.kitware.com/cmake/cmake/issues/19820
#
# 2/
# To see the python link line: Do python-config  --ldflags, i.e
#   > /usr/local/apps/python/2.7.8-01/bin/python-config  --ldflags
#   > -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# However on cct we get:
#   > /usr/local/apps/python/2.7.5-01/bin/python-config --ldflags
#   > -L/usr/local/apps/python/2.7.5-01/lib/python2.7/config -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# cct is correct as it has the "-L" but on other machines we rely on /usr/lib/libpython2.7.so.1.0 being there!
# lxop-test does not have /usr/lib/libpython2.7.so.1.0 so ecbuild fails
#
# For problems with the python build, please look in <build-dir>/ecbuild.log, typically non developmental python
# installs may not include python libs or includes
# For ubuntoo to install we need:
#    sudo apt-get install libpython-dev
#

# =============================================================================
# Configure __init__.py to add __version__
# =============================================================================
set(INIT_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py.in")
set(INIT_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py")
configure_file(${INIT_PY_IN} ${INIT_PY_OUT} )


# =============================================================================
# Configure setup.py. Note used locally. Uses existing libraries
# =============================================================================
set(SETUP_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
set(SETUP_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/setup.py")
configure_file(${SETUP_PY_IN} ${SETUP_PY_OUT} )

# ==============================================================================
# source files (paths relative to dirs python2/python3)
# ==============================================================================
set(srcs
  # Headers
  ../src/ecflow/python/BoostPythonUtil.hpp
  ../src/ecflow/python/ClientDoc.hpp
  ../src/ecflow/python/DefsDoc.hpp
  ../src/ecflow/python/Edit.hpp
  ../src/ecflow/python/GlossaryDoc.hpp
  ../src/ecflow/python/NodeAttrDoc.hpp
  ../src/ecflow/python/NodeUtil.hpp
  ../src/ecflow/python/Trigger.hpp
  # Sources
  ../src/ecflow/python/BoostPythonUtil.cpp
  ../src/ecflow/python/ClientDoc.cpp
  ../src/ecflow/python/DefsDoc.cpp
  ../src/ecflow/python/EcfExt.cpp
  ../src/ecflow/python/Edit.cpp
  ../src/ecflow/python/ExportClient.cpp
  ../src/ecflow/python/ExportCore.cpp
  ../src/ecflow/python/ExportDefs.cpp
  ../src/ecflow/python/ExportNode.cpp
  ../src/ecflow/python/ExportNodeAttr.cpp
  ../src/ecflow/python/ExportSuiteAndFamily.cpp
  ../src/ecflow/python/ExportTask.cpp
  ../src/ecflow/python/GlossaryDoc.cpp
  ../src/ecflow/python/NodeAttrDoc.cpp
  ../src/ecflow/python/NodeUtil.cpp
  ../src/ecflow/python/Trigger.cpp
)

# =====================================================================
# tests
# =====================================================================
set(u_tests
  py_u_test_add
  py_u_test_collection
  py_u_test_cron
  py_u_test_defs_constructor
  py_u_test_get_attr
  py_u_test_manual
  py_u_test_node
  py_u_test_late
  py_u_test_replace_node
  py_u_test_tutorial
  py_u_TestAddDelete
  py_u_TestAddDeleteFunc
  py_u_TestAddNodeFunc
  py_u_TestAutoAddExtern
  py_u_TestAviso
  py_u_TestCopy
  py_u_TestDefs
  py_u_TestDefsCheck
  py_u_TestDerivable
  py_u_TestEcf
  py_u_TestError
  py_u_TestFind
  py_u_TestFlag
  py_u_TestGetAllTasks
  py_u_TestJobGeneration
  py_u_TestMirror
  py_u_TestParent
  py_u_TestRemove
  py_u_TestRepeatArithmetic
  py_u_TestSimulator
  py_u_TestTraversal
  py_u_TestUserManual
  py_u_TestWith
  py_u_sort
)

set(s_tests
  s_TestClientApi
  s_TestPythonChildApi
)


message( STATUS "====================================================================================================================" )
message( STATUS "PYTHON2" )
message( STATUS "====================================================================================================================" )
if(${CMAKE_VERSION} VERSION_LESS "3.12.0") 
  # We only support python2 extension for cmake less 3.12.0
  # cmake 3.12.0 or greater allows multiple boost python libs & hence multiple extensions to be built
  # Using -DPYTHON_EXECUTABLE=/usr/local/apps/python3/3.6.5-01/bin/python3 is not sufficient as the wrong(python2) libs are found
  ecbuild_find_python( VERSION 2.6 REQUIRED )  
  message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
  message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
  message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
  message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
  message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
  message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
  message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
  message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
  message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
  message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
  message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )
  if (${PYTHON_VERSION_MAJOR} EQUAL 3)
    ecbuild_error("Need cmake version >= 3.12.0 to build ecflow python3 extension, current cmake version is ${CMAKE_VERSION}")
  endif()

  find_package( Boost ${ECFLOW_BOOST_VERSION} REQUIRED COMPONENTS python )
  add_subdirectory( python2 )
else()
  # ======================================================================================
  # Attempt to build both python2 *AND/OR* python3 ecflow extension, depending on what is found
  # this assumes cmake 3.12.0 min, which added support for boost python2 and python3
  # * NOTICE* that we do *NOT* use REQUIRED when searching for boost python libs
  # ======================================================================================
  find_package(Python2 COMPONENTS Interpreter Development)
  if (Python2_FOUND)
    message( STATUS "  Python2_Interpreter_FOUND         : ${Python2_Interpreter_FOUND}" )
    message( STATUS "  Python2_EXECUTABLE                : ${Python2_EXECUTABLE}" )
    message( STATUS "  Python2_STDLIB                    : ${Python2_STDLIB}    Standard platform independent installation directory" )
    message( STATUS "  Python2_STDARCH                   : ${Python2_STDARCH}   Standard platform dependent installation directory." )
    message( STATUS "  Python2_Development_FOUND         : ${Python2_Development_FOUND}" )
    message( STATUS "  Python2_INCLUDE_DIRS              : ${Python2_INCLUDE_DIRS}" )
    message( STATUS "  Python2_LIBRARIES                 : ${Python2_LIBRARIES}" )
    message( STATUS "  Python2_LIBRARY_DIRS              : ${Python2_LIBRARY_DIRS}" )
    message( STATUS "  Python2_VERSION                   : ${Python2_VERSION}" )
    message( STATUS "  Python2_VERSION_MAJOR             : ${Python2_VERSION_MAJOR}" )
    message( STATUS "  Python2_VERSION_MINOR             : ${Python2_VERSION_MINOR}" )
    message( STATUS "  Python2_VERSION_PATCH             : ${Python2_VERSION_PATCH}" )
    # *****************************************************************************************
    # Although we have found python2 it could be that *ONLY* python3 was module loaded
    # Otherwise will build for python2 and test with python3 interpreter
    # *****************************************************************************************
    if ( Python2_LIBRARIES )
      ecbuild_find_python( VERSION 2.6 REQUIRED ) # if not included iterpreter not found ?
      if ( ${PYTHON_VERSION_MAJOR} EQUAL 2)
        message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
        message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
        message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
        message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
        message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
        message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
        message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
        message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
        message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
        message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
        message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )

        if ( Boost_MINOR_VERSION GREATER 66 )
          # cmake 3.15
          # see: https://gitlab.kitware.com/cmake/cmake/issues/19656
          # INTERFACE_LIBRARY targets may only have whitelisted properties."
          set(ECFLOW_BOOST_PYTHON_COMPONENT python${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR})
        else()
          set(ECFLOW_BOOST_PYTHON_COMPONENT python)
        endif()
        find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS ${ECFLOW_BOOST_PYTHON_COMPONENT} )

        if (Boost_PYTHON_FOUND OR Boost_PYTHON${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR}_FOUND)
          # Indicate that both Python and Boost.Python have been found
          set(ECF_PYTHON_FOUND "ECF_PYTHON_FOUND")
          add_subdirectory( python2 )
        else()
          message( STATUS "  Boost python2 libraries *NOT* found" )
        endif()
      endif()
    else()
      message( STATUS "  Python2 libraries *NOT* found" )
    endif()
  endif()

  message( STATUS "====================================================================================================================" )
  message( STATUS "PYTHON3" )
  message( STATUS "====================================================================================================================" )
  # The python must include the Development packages. As the headers in these packages is used by boost python.
  find_package(Python3 COMPONENTS Interpreter Development)
  if (Python3_FOUND)
    message( STATUS "  Python3_Interpreter_FOUND         : ${Python3_Interpreter_FOUND}" )
    message( STATUS "  Python3_EXECUTABLE                : ${Python3_EXECUTABLE}" )
    message( STATUS "  Python3_STDLIB                    : ${Python3_STDLIB}    Standard platform independent installation directory" )
    message( STATUS "  Python3_STDARCH                   : ${Python3_STDARCH}   Standard platform dependent installation directory." )
    message( STATUS "  Python3_Development_FOUND         : ${Python3_Development_FOUND}" )
    message( STATUS "  Python3_INCLUDE_DIRS              : ${Python3_INCLUDE_DIRS}" )
    message( STATUS "  Python3_LIBRARIES                 : ${Python3_LIBRARIES}" )
    message( STATUS "  Python3_LIBRARY_DIRS              : ${Python3_LIBRARY_DIRS}" )
    message( STATUS "  Python3_VERSION                   : ${Python3_VERSION}" )
    message( STATUS "  Python3_VERSION_MAJOR             : ${Python3_VERSION_MAJOR}" )
    message( STATUS "  Python3_VERSION_MINOR             : ${Python3_VERSION_MINOR}" )
    message( STATUS "  Python3_VERSION_PATCH             : ${Python3_VERSION_PATCH}" )

    # Set (deprecated) FindPython variables

=== libs/udp/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# ==============================================================================
# ECFLOW UDP server

set(SERVER_TARGET ecflow_udp)

set(${SERVER_TARGET}_srcs
  # Sources
  src/ecflow/udp/UDPServerMain.cpp
)

ecbuild_add_executable(
  TARGET ${SERVER_TARGET}
  SOURCES ${${SERVER_TARGET}_srcs}
  INCLUDES
    src
  LIBS
    ecflow_all
)
set_target_properties(${SERVER_TARGET} PROPERTIES
  INSTALL_RPATH ""
)
target_clangformat(${SERVER_TARGET})


# ==============================================================================
# ECFLOW UDP Client

set(CLIENT_TARGET ecflow_udp_client)

set(${CLIENT_TARGET}_srcs
  # HEADERS
  src/ecflow/udp/UDPClient.hpp
  # SOURCES
  src/ecflow/udp/UDPClientMain.cpp
)

ecbuild_add_executable(
  TARGET ${CLIENT_TARGET}
  SOURCES ${${CLIENT_TARGET}_srcs}
  INCLUDES
    src
  LIBS
    pthread
    Boost::boost
    Boost::filesystem
)
set_target_properties(${CLIENT_TARGET} PROPERTIES
  INSTALL_RPATH ""
)

target_clangformat(${CLIENT_TARGET})

# ==============================================================================
# ECFLOW UDP Test(s)

set(TEST_TARGET s_udp)

list(APPEND ${TEST_TARGET}_srcs
  # HEADERS
  test/TestSupport.hpp
  # SOURCES
  test/TestUDP_main.cpp
  test/TestUDPServer.cpp
)

ecbuild_add_test(
  TARGET
    ${TEST_TARGET}
  LABELS
    integration nightly
  SOURCES
    ${${TEST_TARGET}_srcs}
  LIBS
    ${LIB_TARGET}
    ecflow_all
    Boost::boost
    Boost::unit_test_framework
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
  DEPENDS
    ecflow_server # the server is launched to support tests
    ${SERVER_TARGET}
  DEFINITIONS
    ${BOOST_TEST_DYN_LINK}
  INCLUDES
    src
  WORKING_DIRECTORY
    ${CMAKE_CURRENT_BINARY_DIR}/test_sandbox
  ENVIRONMENT
    "PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}"
)

target_clangformat(${TEST_TARGET} CONDITION ENABLE_TESTS)

file(COPY test/data/reference.def DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/test_sandbox/data)

=== Viewer/ecflowUI/src/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(viewer_srcs
  # Headers
  AboutDialog.hpp
  AbstractNodeModel.hpp
  AbstractNodeView.hpp
  AbstractSearchLine.hpp
  AbstractTextEditSearchInterface.hpp
  ActionHandler.hpp
  AddLabelDialog.hpp
  AddModelColumnDialog.hpp
  Animation.hpp
  AstCollateVNodesVisitor.hpp
  AttributeEditor.hpp
  AttributeEditorFactory.hpp
  CaseSensitiveButton.hpp
  ChangeNotify.hpp
  ChangeNotifyDialog.hpp
  ChangeNotifyEditor.hpp
  ChangeNotifyModel.hpp
  ChangeNotifyWidget.hpp
  ClockWidget.hpp
  CodeItemWidget.hpp
  ComboMulti.hpp
  CommandDesignerWidget.hpp
  CommandHandler.hpp
  CommandOutput.hpp
  CommandOutputDialog.hpp
  CommandOutputWidget.hpp
  CompactView.hpp
  ConfigListDelegate.hpp
  ConnectState.hpp
  CustomCommandDialog.hpp
  CustomCommandHandler.hpp
  CustomListWidget.hpp
  CustomTabWidget.hpp
  Dashboard.hpp
  DashboardDialog.hpp
  DashboardDock.hpp
  DashboardTitle.hpp
  DashboardWidget.hpp
  DiagData.hpp
  EditItemWidget.hpp
  EditProvider.hpp
  EditorInfoLabel.hpp
  EventEditor.hpp
  ExpandState.hpp
  ExpandStateNode.hpp
  FetchTask.hpp
  FileFetchTask.hpp
  FileInfoLabel.hpp
  FileWatcher.hpp
  FilterWidget.hpp
  FlagSet.hpp
  FontMetrics.hpp
  GenFileProvider.hpp
  GotoLineDialog.hpp
  Highlighter.hpp
  HistoryItemWidget.hpp
  HtmlEdit.hpp
  HtmlItemWidget.hpp
  InfoPanel.hpp
  InfoPanelHandler.hpp
  InfoPanelItem.hpp
  InfoPresenter.hpp
  InfoProvider.hpp
  InputEventLog.hpp
  JobItemWidget.hpp
  JobStatusItemWidget.hpp
  LabelEditor.hpp
  LimitEditor.hpp
  LineEdit.hpp
  LogProvider.hpp
  LogViewerCom.hpp
  MainWindow.hpp
  ManualItemWidget.hpp
  MenuConfigDialog.hpp
  MenuHandler.hpp
  MessageItemWidget.hpp
  MeterEditor.hpp
  ModelColumn.hpp
  NodeExpression.hpp
  NodeFilterDialog.hpp
  NodeObserver.hpp
  NodePanel.hpp
  NodePathWidget.hpp
  NodeQuery.hpp
  NodeQueryCombo.hpp
  NodeQueryEditor.hpp
  NodeQueryEngine.hpp
  NodeQueryHandler.hpp
  NodeQueryOption.hpp
  NodeQueryOptionEdit.hpp
  NodeQueryResult.hpp
  NodeQueryResultModel.hpp
  NodeQueryResultTmp.hpp
  NodeQueryResultView.hpp
  NodeQueryViewDelegate.hpp
  NodeSearchWidget.hpp
  NodeSearchWindow.hpp
  NodeViewBase.hpp
  NodeViewDelegate.hpp
  NodeWidget.hpp
  OneLineTextEdit.hpp
  OutputBrowser.hpp
  OutputCache.hpp
  OutputClient.hpp
  OutputDirClient.hpp
  OutputDirProvider.hpp
  OutputDirWidget.hpp
  OutputFetchInfo.hpp
  OutputFileClient.hpp
  OutputFileProvider.hpp
  OutputItemWidget.hpp
  OutputModel.hpp
  OverviewItemWidget.hpp
  OverviewProvider.hpp
  PlainTextEdit.hpp
  PlainTextSearchInterface.hpp
  PlainTextSearchLine.hpp
  PlainTextWidget.hpp
  PropertyDialog.hpp
  PropertyEditor.hpp
  PropertyLine.hpp
  PropertyMapper.hpp
  RectMetrics.hpp
  RepeatEditor.hpp
  RichTextEdit.hpp
  RichTextSearchInterface.hpp
  RichTextSearchLine.hpp
  SaveSessionAsDialog.hpp
  ScriptItemWidget.hpp
  ServerComInfoWidget.hpp
  ServerComObserver.hpp
  ServerComQueue.hpp
  ServerComThread.hpp
  ServerDefsAccess.hpp
  ServerFilter.hpp
  ServerHandler.hpp
  ServerItem.hpp
  ServerList.hpp
  ServerListDialog.hpp
  ServerListSyncWidget.hpp
  ServerLoadItemWidget.hpp
  ServerObserver.hpp
  ServerSettingsItemWidget.hpp
  SessionDialog.hpp
  SessionHandler.hpp
  SessionRenameDialog.hpp
  ShellCommand.hpp
  ShortcutHelpDialog.hpp
  Sound.hpp
  Spline.hpp
  StandardView.hpp
  StringMatchCombo.hpp
  StringMatchMode.hpp
  SuiteFilter.hpp
  SuiteFilterObserver.hpp
  SuiteItemWidget.hpp
  SuiteModel.hpp
  TabWidget.hpp
  TableFilterWidget.hpp
  TableNodeModel.hpp
  TableNodeSortModel.hpp
  TableNodeView.hpp
  TableNodeViewDelegate.hpp
  TableNodeWidget.hpp
  TextEditSearchLine.hpp
  TextFilterHandler.hpp
  TextFilterHandlerDialog.hpp
  TextFilterWidget.hpp
  TimelineData.hpp
  TimelineFileList.hpp
  TimelineHeaderView.hpp
  TimelineInfoDailyView.hpp
  TimelineInfoDailyWidget.hpp
  TimelineInfoDelegate.hpp
  TimelineInfoWidget.hpp
  TimelineItemWidget.hpp
  TimelineModel.hpp
  TimelinePreLoadDialog.hpp
  TimelineView.hpp
  TimelineWidget.hpp
  TreeNodeModel.hpp
  TreeNodeView.hpp
  TreeNodeViewDelegate.hpp
  TreeNodeWidget.hpp
  TreeView.hpp
  TriggerCollector.hpp
  TriggerEditor.hpp
  TriggerGraphLayoutBuilder.hpp
  TriggerGraphModel.hpp
  TriggerGraphView.hpp
  TriggerGraphWidget.hpp
  TriggerItemWidget.hpp
  TriggerTableModel.hpp
  TriggerTableView.hpp
  TriggerTableWidget.hpp
  TriggerTextWidget.hpp
  TriggerViewDelegate.hpp
  TriggeredScanner.hpp
  UiLogS.hpp
  UpdateTimer.hpp
  VAttribute.hpp
  VAttributeType.hpp
  VAutoArchiveAttr.hpp
  VAutoCancelAttr.hpp
  VAutoRestoreAttr.hpp
  VAvisoAttr.hpp
  VConfig.hpp
  VConfigLoader.hpp
  VDateAttr.hpp
  VDir.hpp
  VEventAttr.hpp
  VFile.hpp
  VFileInfo.hpp
  VFileTransfer.hpp
  VFileUncompress.hpp
  VFilter.hpp
  VGenVarAttr.hpp
  VIcon.hpp
  VInfo.hpp
  VItem.hpp
  VItemPathParser.hpp
  VLabelAttr.hpp
  VLateAttr.hpp
  VLimitAttr.hpp
  VLimiterAttr.hpp
  VMeterAttr.hpp
  VMirrorAttr.hpp
  VModelData.hpp
  VNState.hpp
  VNode.hpp
  VNodeList.hpp
  VNodeMover.hpp
  VNodeStateDiag.hpp
  VParam.hpp
  VProperty.hpp
  VQueueAttr.hpp
  VRepeatAttr.hpp
  VReply.hpp
  VReportMaker.hpp
  VSState.hpp
  VServerSettings.hpp
  VSettings.hpp
  VSettingsLoader.hpp
  VTask.hpp
  VTaskNode.hpp
  VTaskObserver.hpp
  VTimeAttr.hpp
  VTree.hpp
  VTriggerAttr.hpp
  VUserVarAttr.hpp
  VariableEditor.hpp
  VariableItemWidget.hpp
  VariableModel.hpp
  VariableModelData.hpp
  VariableModelDataObserver.hpp
  VariableSearchLine.hpp
  VariableView.hpp
  Viewer.hpp
  ViewerUtil.hpp
  WhyItemWidget.hpp
  WidgetNameProvider.hpp
  WmWorkspaceHandler.hpp
  ZombieItemWidget.hpp
  ZombieModel.hpp
  TextPager/TextCodecWrapper.hpp
  TextPager/TextPagerCursor.hpp
  TextPager/TextPagerCursor_p.hpp
  TextPager/TextPagerDocument.hpp
  TextPager/TextPagerDocument_p.hpp
  TextPager/TextPagerEdit.hpp
  TextPager/TextPagerEdit_p.hpp
  TextPager/TextPagerLayout_p.hpp
  TextPager/TextPagerSearchHighlighter.hpp
  TextPager/TextPagerSearchInterface.hpp
  TextPager/TextPagerSection.hpp
  TextPager/TextPagerSection_p.hpp
  TextPager/TextPagerWidget.hpp
  TextPager/WeakPointer.hpp
  TextPager/syntaxhighlighter.hpp
  $<$<BOOL:${ECFLOW_LOGVIEW}>:LogLoadWidget.hpp>
  $<$<BOOL:${ECFLOW_LOGVIEW}>:LogLoadView.hpp>
  # Sources
  ViewerMain.cpp
  AboutDialog.cpp
  AbstractNodeModel.cpp
  AbstractNodeView.cpp
  AbstractSearchLine.cpp
  AbstractTextEditSearchInterface.cpp
  ActionHandler.cpp
  AddLabelDialog.cpp
  AddModelColumnDialog.cpp
  Animation.cpp
  AstCollateVNodesVisitor.cpp
  AttributeEditor.cpp
  AttributeEditorFactory.cpp   
  CaseSensitiveButton.cpp
  ChangeNotify.cpp
  ChangeNotifyDialog.cpp
  ChangeNotifyEditor.cpp
  ChangeNotifyModel.cpp
  ChangeNotifyWidget.cpp
  ClockWidget.cpp
  CodeItemWidget.cpp
  ComboMulti.cpp
  CommandDesignerWidget.cpp
  CommandHandler.cpp
  CommandOutput.cpp
  CommandOutputDialog.cpp
  CommandOutputWidget.cpp
  CompactView.cpp
  ConfigListDelegate.cpp
  ConnectState.cpp
  CustomCommandDialog.cpp
  CustomCommandHandler.cpp
  CustomListWidget.cpp
  CustomTabWidget.cpp
  Dashboard.cpp
  DashboardDialog.cpp
  DashboardDock.cpp
  DashboardTitle.cpp
  DashboardWidget.cpp
  DiagData.cpp
  EditItemWidget.cpp
  EditProvider.cpp
  EditorInfoLabel.cpp
  EventEditor.cpp
  ExpandState.cpp
  ExpandStateNode.cpp
  FetchTask.cpp
  FlagSet.hpp
  FileFetchTask.cpp
  FileInfoLabel.cpp   
  FileWatcher.cpp
  FilterWidget.cpp
  FontMetrics.cpp
  GenFileProvider.cpp
  GotoLineDialog.cpp
  Highlighter.cpp
  HistoryItemWidget.cpp
  HtmlEdit.cpp
  HtmlItemWidget.cpp
  InfoPanel.cpp 
  InfoPanelItem.cpp   
  InfoPanelHandler.cpp
  InfoProvider.cpp
  InputEventLog.cpp
  JobItemWidget.cpp
  JobStatusItemWidget.cpp
  LabelEditor.cpp
  LimitEditor.cpp
  LineEdit.cpp  
  LogProvider.cpp   
  LogViewerCom.cpp
  MainWindow.cpp
  ManualItemWidget.cpp 
  MenuConfigDialog.cpp
  MenuHandler.cpp
  MessageItemWidget.cpp
  MeterEditor.cpp
  ModelColumn.cpp
  NodeExpression.cpp
  NodeFilterDialog.cpp  
  NodePanel.cpp
  NodePathWidget.cpp
  NodeQuery.cpp
  NodeQueryCombo.cpp
  NodeQueryEditor.cpp
  NodeQueryEngine.cpp
  NodeQueryHandler.cpp
  NodeQueryOption.cpp
  NodeQueryOptionEdit.cpp
  NodeQueryResult.cpp
  NodeQueryResultModel.cpp
  NodeQueryResultView.cpp
  NodeQueryViewDelegate.cpp
  NodeSearchWindow.cpp
  NodeSearchWidget.cpp
  NodeViewBase.cpp
  NodeViewDelegate.cpp
  NodeWidget.cpp
  OneLineTextEdit.cpp
  OutputBrowser.cpp
  OutputCache.cpp
  OutputClient.cpp
  OutputFetchInfo.cpp
  OutputFileClient.cpp
  OutputDirClient.cpp
  OutputModel.cpp
  OutputItemWidget.cpp
  OutputFileProvider.cpp
  OutputDirProvider.cpp
  OutputDirWidget.cpp
  OverviewItemWidget.cpp
  OverviewProvider.cpp
  PlainTextEdit.cpp
  PlainTextSearchLine.cpp
  PlainTextSearchInterface.cpp
  PlainTextWidget.cpp
  PropertyDialog.cpp
  PropertyEditor.cpp
  PropertyLine.cpp
  PropertyMapper.cpp
  RectMetrics.cpp
  RepeatEditor.cpp
  RichTextEdit.cpp
  RichTextSearchInterface.cpp
  RichTextSearchLine.cpp
  SaveSessionAsDialog.cpp
  ScriptItemWidget.cpp
  ServerComInfoWidget.cpp
  ServerComQueue.cpp
  ServerComThread.cpp
  ServerDefsAccess.cpp
  ServerHandler.cpp
  ServerFilter.cpp
  ServerItem.cpp
  ServerList.cpp
  ServerListDialog.cpp
  ServerListSyncWidget.cpp   
  ServerLoadItemWidget.cpp
  ServerSettingsItemWidget.cpp
  SessionDialog.cpp
  SessionRenameDialog.cpp
  SessionHandler.cpp
  ShellCommand.cpp
  ShortcutHelpDialog.cpp
  Sound.cpp
  Spline.cpp
  StandardView.cpp
  StringMatchCombo.cpp
  StringMatchMode.cpp
  SuiteItemWidget.cpp
  SuiteFilter.cpp
  SuiteFilterObserver.hpp
  SuiteModel.cpp
  TabWidget.cpp 
  TableFilterWidget.cpp
  TableNodeModel.cpp
  TableNodeSortModel.cpp
  TableNodeView.cpp
  TableNodeViewDelegate.cpp
  TableNodeWidget.cpp
  TextEditSearchLine.cpp
  TextFilterHandler.cpp
  TextFilterHandlerDialog.cpp
  TextFilterWidget.cpp   
  TimelineHeaderView.cpp
  TimelineInfoDailyView.cpp
  TimelineInfoDailyWidget.cpp
  TimelineInfoDelegate.cpp
  TimelineInfoWidget.cpp
  TimelineItemWidget.cpp
  TimelineData.cpp
  TimelineFileList.cpp
  TimelineModel.cpp
  TimelinePreLoadDialog.cpp
  TimelineView.cpp
  TimelineWidget.cpp
  TreeNodeModel.cpp
  TreeNodeView.cpp
  TreeNodeViewDelegate.cpp
  TreeNodeWidget.cpp
  TreeView.cpp
  TriggerEditor.cpp   
  TriggerItemWidget.cpp
  TriggerTextWidget.cpp  
  TriggerCollector.cpp
  TriggerGraphLayoutBuilder.cpp
  TriggerGraphModel.cpp
  TriggerGraphWidget.cpp
  TriggerGraphView.cpp
  TriggerTableModel.cpp
  TriggerTableView.cpp
  TriggerTableWidget.cpp
  TriggerViewDelegate.cpp
  TriggeredScanner.cpp  
  UiLogS.cpp
  UpdateTimer.cpp
  VAttribute.cpp
  VAttributeType.cpp
  VAutoArchiveAttr.cpp
  VAutoCancelAttr.cpp
  VAutoRestoreAttr.cpp
  VAvisoAttr.cpp
  VConfig.cpp
  VConfigLoader.cpp
  VDateAttr.cpp
  VDir.cpp
  VEventAttr.cpp
  VFilter.cpp
  VIcon.cpp
  VInfo.cpp
  VFile.cpp
  VFileInfo.cpp
  VFileTransfer.cpp
  VFileUncompress.cpp
  VItem.cpp
  VItemPathParser.cpp
  VLabelAttr.cpp
  VLateAttr.cpp
  VLimitAttr.cpp
  VLimiterAttr.cpp
  VMeterAttr.cpp
  VMirrorAttr.cpp
  VModelData.cpp
  VNode.cpp
  VNodeList.cpp
  VNodeMover.cpp
  VNodeStateDiag.cpp
  VNState.cpp
  VParam.cpp
  VProperty.cpp
  VQueueAttr.cpp
  VRepeatAttr.cpp
  VReply.cpp
  VReportMaker.cpp
  VServerSettings.cpp
  VSettings.cpp
  VSettingsLoader.cpp
  VSState.cpp
  VTask.cpp
  VTaskNode.cpp
  VTimeAttr.cpp
  VTree.cpp
  VTriggerAttr.cpp
  VGenVarAttr.cpp
  VUserVarAttr.cpp
  VariableEditor.cpp
  VariableModel.cpp
  VariableModelData.cpp
  VariableItemWidget.cpp
  VariableSearchLine.cpp
  VariableView.cpp
  ViewerUtil.cpp
  WhyItemWidget.cpp
  WidgetNameProvider.cpp
  WmWorkspaceHandler.cpp
  ZombieItemWidget.cpp
  ZombieModel.cpp
  TextPager/TextPagerCursor.cpp

=== libs/pyext/python2/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

ecbuild_add_library(
  TARGET
    ecflow2
  NOINSTALL
  TYPE MODULE
  SOURCES
    ${srcs}
  PRIVATE_INCLUDES
    ../src
  PUBLIC_LIBS
    ecflow_all
    libsimulator
    Python2::Python
    Boost::${ECFLOW_BOOST_PYTHON_COMPONENT}
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
  CXXFLAGS
    $<$<CXX_COMPILER_ID:Clang>:-Wno-macro-redefined>
)

target_clangformat(ecflow2)

#
# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#         
# by default cmake add prefix 'lib', we don't want this hence disable
#
# To avoid duplicate target names we chose to name the targets: ecflow2/ecflow3.
# however test and user code  depend on name 'ecflow', hence we rename the output to 'cflow'
set_target_properties(ecflow3
  PROPERTIES
    OUTPUT_NAME "ecflow"
    PREFIX ""
    INSTALL_RPATH ""
)

# =====================================================================
# tests

foreach( test ${u_tests} )
  ecbuild_add_test(
    TARGET
      py2_${test}
    LABELS
      python nightly
    TYPE PYTHON
    ARGS
      ${CMAKE_CURRENT_SOURCE_DIR}/../test/${test}.py
    ENVIRONMENT
      "PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}"
    TEST_DEPENDS
      u_base
  )
endforeach()


if ( ENABLE_ALL_TESTS AND ENABLE_SERVER)

  foreach( test ${s_tests} )
    ecbuild_add_test(
      TARGET
        py2_${test}
      LABELS
        python nightly
      TYPE PYTHON
      ARGS
        ${CMAKE_CURRENT_SOURCE_DIR}/../test/${test}.py
      ENVIRONMENT
        "PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}"
      TEST_DEPENDS
        u_base
    )
  endforeach()
  
  set_property(TEST py2_s_TestClientApi      APPEND PROPERTY DEPENDS s_test)
  set_property(TEST py2_s_TestPythonChildApi APPEND PROPERTY DEPENDS py_s_TestClientApi)
endif()


# ==========================================================================
# install
#    -DCMAKE_PYTHON_INSTALL_TYPE = [ local | setup | not defined ]
#
#    local | not defined : this will install to:
#                          $INSTALL_PREFIX/$release.$major.$minor/lib/python2.7/site-packages/ecflow/
#    setup               : experimental only,python way of installing
#
#    -DCMAKE_PYTHON_INSTALL_PREFIX should *only* used when using python setup.py (CMAKE_PYTHON_INSTALL_TYPE=setup)
#    *AND* for testing python install to local directory
#
# Note:  To install only the python module
#       cd  buildir
#       cmake -DCMAKE_INSTALL_PREFIX=$INSTALL_DIR -DCOMPONENT=python -P cmake_install.cmake -- make install
# ==========================================================================

if( CMAKE_PYTHON_INSTALL_TYPE MATCHES  "local"  OR NOT DEFINED CMAKE_PYTHON_INSTALL_TYPE )

  message(STATUS "python install *LOCAL* +++ lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/ecflow +++++++")
  if( NOT INSTALL_PYTHON2_DIR )
    set(PYTHON_SITE "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages" )
  else()
    # Resolve ${VAR} in the value provided
    string(CONFIGURE "${INSTALL_PYTHON2_DIR}" PYTHON_SITE)
  endif()
  set(PYTHON_DEST "${PYTHON_SITE}/ecflow" )

  install(
    TARGETS
      ecflow2
    DESTINATION
      ${PYTHON_DEST}
    RENAME
      ecflow.so
    COMPONENT
      python
  )
  install(
    FILES
      ../ecflow/__init__.py
      ../samples/api/ecf.py
      ../samples/api/sms2ecf.py
    DESTINATION
      ${PYTHON_DEST}
    COMPONENT
      python
  )

else()

  message( STATUS "python found,  CMAKE_PYTHON_INSTALL_TYPE=${CMAKE_PYTHON_INSTALL_TYPE}")

  # -------------------------------------------------------------------------------------
  # Install using setup.py
  # See: http://bloerg.net/2012/11/10/cmake-and-distutils.html
  # -------------------------------------------------------------------------------------
  message(STATUS "python install using *setup.py* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
  message(STATUS "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}")
  message(STATUS "CMAKE_BINARY_DIR=${CMAKE_BINARY_DIR}")
  message(STATUS "CMAKE_PYTHON_INSTALL_PREFIX : ${CMAKE_PYTHON_INSTALL_PREFIX}" )

  set(SETUP_PY_IN "${CMAKE_CURRENT_SOURCE_DIR}/../setup.py.in")
  set(SETUP_PY    "${CMAKE_CURRENT_SOURCE_DIR}/../setup.py")
  set(DEPS        "${CMAKE_CURRENT_SOURCE_DIR}/../ecflow/__init__.py")
  set(OUTPUT      "${CMAKE_CURRENT_SOURCE_DIR}/timestamp")

  configure_file(${SETUP_PY_IN} ${SETUP_PY} )

  add_custom_command(
    OUTPUT ${OUTPUT}
    COMMAND ${PYTHON} ${SETUP_PY} build
    COMMAND ${CMAKE_COMMAND} -E touch ${OUTPUT}
    DEPENDS ${DEPS}
  )
  add_custom_target(target ALL DEPENDS ${OUTPUT})

  install(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} build_ext)")

  if( DEFINED CMAKE_PYTHON_INSTALL_PREFIX )
    message(STATUS "custom/*test* python install prefix defined CMAKE_PYTHON_INSTALL_PREFIX=${CMAKE_PYTHON_INSTALL_PREFIX}")
    install(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} install -f --prefix=${CMAKE_PYTHON_INSTALL_PREFIX})")
  else()
    install(CODE "execute_process(COMMAND ${PYTHON} ${SETUP_PY} install)")
  endif()
endif()

=== debian/changelog ===
ecflow (5.13.7-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 22:03:54 +0000

ecflow (5.13.7-1) unstable; urgency=medium

  * Drop B-D on dh-buildinfo
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 08 Feb 2025 05:18:38 +0000

=== debian/control ===
Source: ecflow
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-sequence-python3, 
  python3-all-dev,
  ecbuild (>= 3.3.0-3),
  doxygen,
  chrpath, 
  libmotif-dev, 
  libxpm-dev,
  libssl-dev,
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  qt6-charts-dev,
  libqt6opengl6-dev,
  libxkbcommon-dev,
  libboost-test-dev, 
  libboost-serialization-dev,
  libboost-date-time-dev, 
  libboost-timer-dev,
  libboost-chrono-dev,
  libboost-thread-dev,
  libboost-regex-dev, 
  libboost-python-dev (>= 1.71.0-7+b1), 
  libboost-program-options-dev, libboost-filesystem-dev
Standards-Version: 4.7.0
Homepage: https://software.ecmwf.int/wiki/display/ECFLOW/The+ECFLOW+Pre-processor
Vcs-Browser: https://salsa.debian.org/science-team/ecflow.git
Vcs-Git: https://salsa.debian.org/science-team/ecflow.git -b debian/latest


Package: ecflow-server
Architecture: any
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh
Description: Meteorological workflow controller - server 
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.


Package: ecflow-client
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends}, libqt6svg6, ${python3:Depends}, python3-fuse
Description: Client tools for Meteorological workflow
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.
 .
 This package contains the client tools

Package: python3-ecflow
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-fuse
Description: Python3 libraries for ecFlow workflow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 .
 This package contains Python3 modules used in writing ecflow scripts.
